<?php
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
   //--self downloader --
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
}
ob_start();
# curl return codes
# 	Informational 1xx
$codes['100']	=	"Continue";
$codes['101']	=	"Switching Protocols";
#	Successful 2xx
$codes['200']	=	"OK";
$codes['201']	=	"Created";
$codes['202']	=	"Accepted";
$codes['203']	=	"Non-Authoritative Information";
$codes['204']	=	"No Content";
$codes['205']	=	"Reset Content";
$codes['206']	=	"Partial Content";
$codes['226']	=	"Transfer complete";
#	Redirection 3xx
$codes['300']	=	"Multiple Choices";
$codes['301']	=	"Moved Permanently";
$codes['302']	=	"Found";
$codes['303']	=	"See Other";
$codes['304']	=	"Not Modified";
$codes['305']	=	"Use Proxy";
$codes['306']	=	"(Unused)";
$codes['307']	=	"Temporary Redirect";
#	Client Error 4xx
$codes['400']	=	"Bad Request";
$codes['401']	=	"Unauthorized";
$codes['402']	=	"Payment Required";
$codes['403']	=	"Forbidden";
$codes['404']	=	"Not Found";
$codes['405']	=	"Method Not Allowed";
$codes['406']	=	"Not Acceptable";
$codes['407']	=	"Proxy Authentication Required";
$codes['408']	=	"Request Timeout";
$codes['409']	=	"Conflict";
$codes['410']	=	"Gone";
$codes['411']	=	"Length Required";
$codes['412']	=	"Precondition Failed";
$codes['413']	=	"Request Entity Too Large";
$codes['414']	=	"Request-URI Too Long";
$codes['415']	=	"Unsupported Media Type";
$codes['416']	=	"Requested Range Not Satisfiable";
$codes['417']	=	"Expectation Failed";
#	Server Error 5xx
$codes['500']	=	"Internal Server Error";
$codes['501']	=	"Not Implemented";
$codes['502']	=	"Bad Gateway";
$codes['503']	=	"Service Unavailable";
$codes['504']	=	"Gateway Timeout";
$codes['505']	=	"HTTP Version Not Supported";
#
# test program to check if retrievel of essential data is possible for a web-hoster
#
ini_set('display_errors', 'On'); 
error_reporting(E_ALL);	

$website	= 'www.weerstationwaanrode.nu/weather2/';		#### change to website address and folder she scripts should run
$echoAll	= true; 			// true all retrieved info is echo as comment, false = first 100 chars
$StringStart	= '<!-- ';	
$stringEnd	= ' -->';
$replFrom	= array (trim($StringStart),trim($stringEnd));
$extra		= '';
#
if (!isset($_REQUEST['extra']) ) {$extra	= '';}
#
# ### GET CURLs
$arrRead	        = array();      #   http://www.meteoalarm.eu/handheld.php?level=2&area=BE004&day=0&lang=&mod1=0&mod2=0

$arrRead['euWarning1']	= array('link' 	=> 'ftp.knmi.nl/pub_weerberichten/weeroverzicht.xml',
				'page' 	=> $website,
				'txt'	=> 'knmi xml forecast',);					
/*
$arrRead['euWarning2']	= array('link' => 'http://www.meteoalarm.eu/index3.php?area=BE004&day=0&lang=en_UK',
				'page' => $website.'index.php?p=57',
			        'txt'	=> 'EU weather warning using standard extensive html page',);
$arrRead['euWarning3']	= array('link' => 'http://www.meteoalarm.eu/en_UK/0/0/BE004.html',
				'page' => $website,
				'txt'	=> 'EU weather warning using new version extensive html page',);
$arrRead['metarXML'] 	= array('link' => 'http://weather.aero/dataserver_current/httpparam?dataSource=metars&requestType=retrieve&format=xml&hoursBeforeNow=3&mostRecent=true&stationString=EHRD',
				'page' => $website,
				'txt'	=> 'conditions nearby airport - xml file');
$arrRead['yahoo'] 	= array('link' => 'http://xml.weather.yahoo.com/forecastrss/BEXX0026_c.xml', 
				'page' => $website.'index.php?p=53',
				'txt'	=> 'forecast and current conditions as alternative for conditions nearby airport - xml file');
*/
if ($extra <> '') {
        $replFrom       = array ('?','&');
        $replTo         = array ('%3F','%26');
        foreach ($arrRead as $key => $arr) { 
                $string = str_replace ($replFrom,$replTo,$arr['link']);
                $arrRead[$key]['link']=$string;
        }
}
#print_r ($arrRead); exit;
#
echo '<h3>Test program to check if errors occur when retrieving information by using CURL</h3><pre>'.PHP_EOL;
foreach ($arrRead as $key => $arr) {
#
	$url = $extra.$arr['link'];       
	echo 'Test : '.$key.'
== to retrieve:    '.$arr['txt'].'
== using CURL get: '.$url.'
== used on page:   <a href="'.$arr['page'].'">'.$arr['page'].'</a>'.PHP_EOL;
ob_flush();
#
	$ch = curl_init();
	curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt ($ch, CURLOPT_URL, $url);
	curl_setopt ($ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
	curl_setopt ($ch, CURLOPT_TIMEOUT, 20);
	$now 		= microtime(true);
	$rawData 	= curl_exec ($ch);
	$seconds	= microtime(true) - $now;
	$arr		= curl_getinfo ( $ch );
	$returnText	= 'After '.$seconds.' seconds ';
	if(!curl_errno($ch)) {
		$returncode		= $arr['http_code'];
		$returnText		.= ' returncode = '.$returncode;
		if (!isset ($codes[$returncode]) ) {
			$returnText	.= '<b> ?unknown return code? </b>';
		} else {
			$returnText	.= '['.$codes[$returncode].']';
		}
	} else {	
		$returnText	.= ' error returned '.curl_error ($ch);
	}
	curl_close ($ch);
	unset ($ch);
	if (strlen($rawData) < 2) { 
		echo $returnText.' <b>No data retrieved</b>'.PHP_EOL;
		echo $StringStart.$rawData.$stringEnd.PHP_EOL; 
		continue;
	}
	$rawData = str_replace ($replFrom, '', $rawData);
	echo $returnText.' - please check the html source of the page for the detailed-data returned '.PHP_EOL;
	$string = substr($rawData,0, 100);
	if (!$echoAll) {
	        echo $StringStart.PHP_EOL.$string.$stringEnd.PHP_EOL;
	} else {
	        echo $StringStart.PHP_EOL.$rawData.$stringEnd.PHP_EOL;
        }	
	$string = str_replace ('<','&lt;',$string);
	echo 'First 100 chars of returned text ='.$string;
#	echo PHP_EOL;
}
# ### POST CURLs
$arrRead			= array();
/*
$arrRead['usno']= array('link' 	=> 'http://aa.usno.navy.mil/cgi-bin/aa_pap.pl',
			'post'	=> 'FFX=2&ID=AA&xxy=2014&xxm=5&xxd=14&place=wilsele&xx0=1&xx1=6&xx2=32&yy0=1&yy1=53&yy2=17&zz1=2&zz0=1&ZZZ=END',
			'page' 	=> $website.'?p=67',
			'txt'	=> 'real sun moon information for this latitude longitude');
*/
foreach ($arrRead as $key => $arr) {
	$url 	= $extra.$arr['link'];
	$post	= $arr['post'];
	echo 'Test : '.$key.'
== to retrieve:     '.$arr['txt'].'
== using CURL post: '.$url.'
== using referer:   http://aa.usno.navy.mil/data/docs/RS_OneDay.php
== with post parms: '.$post.'
== used on page:    <a href="'.$arr['page'].'">'.$arr['page'].'</a>'.PHP_EOL;
ob_flush();
	$ch 	= curl_init();
	curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt ($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
	curl_setopt ($ch, CURLOPT_TIMEOUT, 10);
	curl_setopt($ch, CURLOPT_REFERER, 'http://aa.usno.navy.mil/data/docs/RS_OneDay.php');
	curl_setopt($ch, CURLOPT_POST , true);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
	$now 		= microtime(true);
	$rawData 	= curl_exec ($ch);
	$seconds	= microtime(true) - $now;
	$arr		= curl_getinfo ( $ch );
	$returnText	= 'After '.$seconds.' seconds ';
	if(!curl_errno($ch)) {
		$returncode		= $arr['http_code'];
		$returnText		.= ' returncode = '.$returncode;
		if (!isset ($codes[$returncode]) ) {
			$returnText	.= '<b> ?unknown return code? </b>';
		} else {
			$returnText	.= '['.$codes[$returncode].']';
		}
	} else {	
		$returnText	.= ' error returned '.curl_errno($ch).'['.curl_error ($ch).']';
	}
	curl_close ($ch);
	unset ($ch);
	if (strlen($rawData) < 2) { 
		echo $returnText.' <b>No data retrieved</b>'.PHP_EOL;
		echo $StringStart.$rawData.$stringEnd.PHP_EOL; 
		continue;
	}
	$rawData = str_replace ($replFrom, '', $rawData);
	echo $returnText.' - please check the html source of the page  for the detailed-data returned '.PHP_EOL;
	if (!$echoAll) {$rawdata = substr($rawData,0, 100);}
	echo $StringStart.PHP_EOL.$rawData.$stringEnd.PHP_EOL;
	echo '<br /><br />'.PHP_EOL;
}
ob_end_flush();
?>